(function() {
  let timer = null;
  const container = document.querySelector('#wrapper_wrapper');

  replaceUrl();

  watchUpdate();

  function replaceUrl() {
    unWatchUpdate();
    const resultLink = [].slice.call(document.querySelectorAll('.result h3 a, .result-op h3 a'), 0);
    resultLink.forEach(function(item) {
      var url = item.getAttribute('href').replace(/&wd.*$/, '');
      if (/https?\:\/\/www\.baidu\.com\/link\?url/.test(url)) {
        getRealLink(url.replace('http', 'https'), function(sc) {
          item.href = sc;
        });
      }
    });
    watchUpdate();
  }


  function getRealLink(url, callback) {
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open('GET', url, true);
    xmlhttp.onload = function() {
      var redirect = this.getResponseHeader('redirect');
      if (redirect) {
        callback(redirect);
      }
    }
    xmlhttp.send();
  }

  function watchUpdate() {
    container.addEventListener('DOMSubtreeModified', function() {
      handleUpdate();
    }, false);
  }

  function unWatchUpdate() {
    container.removeEventListener('DOMSubtreeModified', handleUpdate);
  }

  function handleUpdate() {
    timer && clearTimeout(timer);
    timer = setTimeout(function() {
      replaceUrl();
    });
  }
}());
